#!/usr/local/bin/perl

print "Content-type: text/html\n\n";
print "<HTML>";
print "<BODY bgcolor=white>";
#print "REMOTE_ADDR = $ENV{'REMOTE_HOST'}<BR>\n";

# Decode the user data and place it in the
# data_received associative array.
$user_string = $ENV{'QUERY_STRING'};

#$strn = "|hello";
#($a1, $a2) = split(/\|/, $strn);
#print "$a1, $a2";

# This line changes the + signs to spaces.
$user_string =~ s/\+/ /g;

# This line places each name/value pair as a separate
# element in the name_value_pairs array.
@name_value_pairs = split(/&/, $user_string);

# This code loops over each element in the name_value_pairs
# array, splits it on the = sign, and places the value
# into the user_data associative array with the name as the
# key.
foreach $name_value_pair (@name_value_pairs) {
  ($name, $value) = split(/=/, $name_value_pair);

  # These two lines decode the values from any URL
  # hexadecimal encoding. The first section searches for a
  # hexadecimal number and the second part converts the
  # hex number to decimal and returns the character
  # equivalent.
  $name =~
    s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/ge;
  $value =~
     s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/ge;
  # If the name/value pair has already been given a value,
  # as in the case of multiple items being selected, then
  # separate the items with a " : ".
  if (defined($user_data{$name})) {
    $user_data{$name} .= " : " . $value;
  } 
  else {
    $user_data{$name} = $value;
  }
  if ($name eq "info")
  {
     $infotype = $value;
  }
  if ($name eq "file")
  {
     if ($value=~"ghiya"){
       ($thead, $tfile) = split(/ghiya/, $value);
        $infofile = "/home/acaps/u1/ghiya/public_html".$tfile;
     }
     else{
        $infofile = $value;
    }
  }
}
 $srcfile = $ENV{'REMOTE_ADDR'};

 if ($infotype eq "fields")
 {
   print "The right frame will now display <FONT color=red>structure fields</FONT>";
   print " accessed with respect to <FONT color=blue>heap-directed";
   print " pointers</FONT> in the program.";
   system("/bin/rm -f ../../tmp/mccat.info.$srcfile.html");
   system("/bin/rm -f ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.html ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.fields.html ../../tmp/mccat.info.$srcfile.html");
 }
 if ($infotype eq "connect")
 {
   print "The right frame will now display <FONT color=red>connection relationships";
   print " </FONT>valid at the <FONT color=magenta>clicked statement</FONT>.";
   system("/bin/rm -f ../../tmp/mccat.info.$srcfile.html");
   system("/bin/rm -f ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.html ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.connect.html ../../tmp/mccat.info.$srcfile.html");
 }
 if ($infotype eq "connect_indirect")
 {
   print "The right frame will now display <FONT color=red>connection";
   print " relationships</FONT> "; 
   print " for <FONT color=blue>indirect heap references</FONT>\n";
   print " at the <FONT color=magenta>clicked statement</FONT>.";
   system("/bin/rm -f ../../tmp/mccat.info.$srcfile.html");
   system("/bin/rm -f ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.html ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.connect.i.html ../../tmp/mccat.info.$srcfile.html");
 }
 if ($infotype eq "alias")
 {
   print "The right frame will now display <FONT color=red>points-to</FONT>";
   print " information valid at the <FONT color=magenta>clicked"; 
   print " statement</FONT>."; 
   system("/bin/rm -f ../../tmp/mccat.info.$srcfile.html");
   system("/bin/rm -f ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.html ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.alias.html ../../tmp/mccat.info.$srcfile.html");
 }
 if ($infotype eq "alias_indirect")
 {
   print "The right frame will now display <FONT color=red>points-to </FONT>";
   print " information valid for <FONT color=blue>indirect references</FONT>";
   print " at the <FONT color=magenta>clicked statement</FONT>.";
   system("/bin/rm -f ../../tmp/mccat.info.$srcfile.html");
   system("/bin/rm -f ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.html ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.alias.i.html ../../tmp/mccat.info.$srcfile.html");
 } 
 if ($infotype eq "rw_sets")
 {
   print "The right frame will now display <FONT color=red>read-write set </FONT>";
   print " information valid";
   print " at the <FONT color=magenta>clicked statement</FONT>.";
   system("/bin/rm -f ../../tmp/mccat.info.$srcfile.html");
   system("/bin/rm -f ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.html ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.rw.html ../../tmp/mccat.info.$srcfile.html");
 } 
 if ($infotype eq "heap_rw_sets")
 {
   print "The right frame will now display <FONT color=red>heap read-write set </FONT>";
   print " information valid";
   print " at the <FONT color=magenta>clicked statement</FONT>.";
   system("/bin/rm -f ../../tmp/mccat.info.$srcfile.html");
   system("/bin/rm -f ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.html ../../tmp/mccat.src.$srcfile.html");
   system("/bin/ln -s $infofile.heap.rw.html ../../tmp/mccat.info.$srcfile.html");
 } 

print "</HTML>";
